Public Class SickEplanEdbFunctions

    Public Shared UserDefProp_EDB_DocIdentnr As String = "SICK.ProjectProperty.EDB_Doc_Identnr"
    Public Shared UserDefProp_EDB_DocIdentnr_Display As String = "SICK EDB Doc Identnr"
    Public Shared UserDefProp_EDB_SysIdentnr As String = "SICK.ProjectProperty.EDB_Part_Identnr"
    Public Shared UserDefProp_EDB_SysIdentnr_Display As String = "SICK EDB Part Identnr"
    Public Shared UserDefProp_EDB_Elid As String = "SICK.ProjectProperty.EDB_Elid"
    Public Shared UserDefProp_EDB_Elid_Display As String = "SICK EDB Elid"
    Public Shared UserDefProp_EDB_Version As String = "SICK.ProjectProperty.EDB_Version"
    Public Shared UserDefProp_EDB_Version_Display As String = "SICK EDB Version"
    Public Shared UserDefProp_EDB_Index As String = "SICK.ProjectProperty.EDB_Index"
    Public Shared UserDefProp_EDB_Index_Display As String = "SICK EDB Index"


    Public Sub MenuFunction()
        Dim oMenu As New Eplan.EplApi.Gui.Menu
        Dim sickMainMenu, itemID1 As UInteger
        Dim menubar14, menubar15 As String
        menubar14 = "EDB Funktionen"
        menubar15 = "Test UserDefinedPropertyDefinition"

        sickMainMenu = oMenu.AddMainMenu("SICK-EDB", Eplan.EplApi.Gui.Menu.MainMenuName.eMainMenuUtilities, " ", "EdbAction", "Version 2.5", 1)
        itemID1 = oMenu.AddPopupMenuItem(menubar14, menubar15, "EdbAction", "", sickMainMenu, Integer.MinValue, False, False)

    End Sub


    Sub EdbInterface()
        ProjektSpeichern()
    End Sub


    Public Sub ProjektSpeichern()
        Dim projMan As New DataModel.ProjectManager()
        Dim project As DataModel.Project = Nothing
        Dim oSelectionset As New Eplan.EplApi.HEServices.SelectionSet

        project = projMan.CurrentProject
        getProjDocIdentNr(project)

    End Sub


    Function getProjDocIdentNr(ByRef project As Eplan.EplApi.DataModel.Project) As String

        Dim userPropDef As UserDefinedPropertyDefinition
        Dim sUserPropDef As UserDefinedPropertyDefinition()
        Dim propertyValue As PropertyValue = Nothing

        getProjDocIdentNr = "neu"

        Try

            sUserPropDef = project.UserDefinedPropertyDefinitions()
            For Each userPropDef In sUserPropDef
                If userPropDef.IdentifyingName.Equals(UserDefProp_EDB_DocIdentnr) Then
                    'Falls die Eigenschaft flschlicherweise auf nicht mehr verwenden gesetzt ist, soll hier korrigiert werden.
                    If userPropDef.DoNotUse Then
                        userPropDef.DoNotUse = False
                    End If
                End If
            Next
            propertyValue = project.Properties(UserDefProp_EDB_DocIdentnr)
        Catch ex As Exception

        End Try

        If propertyValue Is Nothing Then
            Throw New Exception("No value for EDB-Identnr. available!")
        Else
            getProjDocIdentNr = propertyValue.ToString
        End If

        Return getProjDocIdentNr
    End Function



End Class
